<script setup>
import { useStore } from "vuex";
import { computed } from "vue";
import ServerLog from "@components/Page/ServerLog.vue";
import AddLevelModal from "@components/Template/AddLevelModal.vue";
import LOGO from "@/assets/adaptor.svg";
import LOGOSOLID from "@/assets/adaptor_solid.svg";

const store = useStore();

const game = computed(() => store.state.game.selected);
const levelList = computed(() => store.state.game.levelList);
const selectedLevel = computed(() => store.state.level.selected);
const isLive = computed(() => store.state.live.isLive);
const isLogOpen = computed(() => store.state.serverLog.isOpen);
const localUser = computed(() => store.state.adaptor.username);
const otherUsers = computed(() => store.state.adaptor.others);

function download(name) {
  const json = JSON.stringify(store.state.level.data, null, 2),
    blob = new Blob([json], { type: "octet/stream" }),
    url = window.URL.createObjectURL(blob),
    downloader = document.createElement("a");
  downloader.href = url;
  downloader.download = `${name}.json`;
  downloader.click();
  window.URL.revokeObjectURL(url);
}

// ToDo: is this necessary!?!
function blur(e) {
  // TODO: refactor for more nested elements clicked
  // TODO: get rid of blur function and automate add a listener to all dropdown menus to hide them after clicking an item - otherwise the menu stays open
  let menu = e.target.parentNode;
  menu.style.display = "none";
  setTimeout(() => {
    e.target.blur();
    // Reset the display property to its original state, so the menu can appear again next time
    menu.style.display = "";
  }, 1);
}
</script>

<template>
  <nav
    class="navbar has-border-bottom has-border-top has-background-adaptor is-unselectable pr-2"
    :class="[isLive ? 'has-background-is-live' : 'has-background-adaptor']"
    role="navigation"
  >
    <div class="navbar-menu">
      <div class="navbar-start">
        <!-- ADAPTOR ICON AND DROPDOWN -->
        <div class="navbar-item has-dropdown has-border-right is-hoverable">
          <a class="navbar-link is-arrowless">
            <img :src="isLive ? LOGOSOLID : LOGO" alt="Adaptor Icon" />
          </a>
          <div class="navbar-dropdown">
            <router-link :to="{ name: 'GamesList' }" class="navbar-item" @click="blur">back to all games</router-link>
            <a class="navbar-item" @click.stop="$store.dispatch('adaptor/setAuth', false)">logout {{ localUser }}</a>
          </div>
        </div>
        <!-- GAME DROPDOWN -->
        <div v-if="$route.params.game" class="navbar-item has-dropdown has-border-right is-hoverable">
          <a class="navbar-link is-arrowless pr-5">GAME</a>
          <div class="navbar-dropdown">
            <router-link
              :to="{ name: 'Overview', params: { game: $route.params.game } }"
              class="navbar-item"
              @click="blur"
            >
              overview
            </router-link>
            <router-link
              :to="{
                name: 'Dashboard',
                params: { game: $route.params.game },
              }"
              class="navbar-item"
              @click="blur"
            >
              dashboard
            </router-link>
            <router-link
              :to="{
                name: 'Collections',
                params: { game: $route.params.game },
              }"
              class="navbar-item"
              @click="blur"
            >
              collections
            </router-link>
            <router-link
              :to="{
                name: 'Settings',
                params: { game: $route.params.game },
              }"
              class="navbar-item"
              @click="blur"
            >
              settings
            </router-link>
          </div>
        </div>
        <!-- LEVEL DROPDOWN -->
        <div v-if="$route.params.level" class="navbar-item has-dropdown has-border-right is-hoverable">
          <a class="navbar-link is-arrowless pr-5">LEVEL</a>
          <div class="navbar-dropdown">
            <router-link
              :to="{
                name: 'Editor',
                params: {
                  game: $route.params.game,
                  level: $route.params.level,
                },
              }"
              class="navbar-item"
              @click="blur"
            >
              edit
            </router-link>
            <router-link
              :to="{
                name: 'Config',
                params: {
                  game: $route.params.game,
                  level: $route.params.level,
                },
              }"
              class="navbar-item"
              @click="blur"
            >
              config
            </router-link>
            <a class="navbar-item" @click="download($route.params.level)">download</a>
          </div>
        </div>
      </div>

      <div class="navbar-end">
        <div class="navbar-item">
          <div v-if="localUser" class="user-dot has-text-weight-semibold" :title="localUser">
            {{ localUser.substring(0, 2) }}
          </div>
          <div v-for="other in otherUsers" :key="other.socket" :title="other.user" class="user-dot">
            {{ other.user.substring(0, 2) }}
          </div>
        </div>
        <router-link
          v-if="$route.params.game"
          :to="{ name: 'Overview', params: { game: $route.params.game } }"
          class="navbar-item has-text-weight-semibold"
          @click="blur"
        >
          {{ $route.params.game }}
        </router-link>
        <div v-if="$route.params.game" class="navbar-item has-dropdown is-hoverable">
          <a class="navbar-link has-text-weight-semibold">
            {{ selectedLevel }}
          </a>
          <div class="navbar-dropdown is-right is-layer-top">
            <router-link
              v-for="level in levelList"
              :key="level.name"
              :to="{
                name: 'Editor',
                params: { game: $route.params.game, level: level.name },
              }"
              class="navbar-item"
              :class="{
                'has-text-weight-bold': level.name == selectedLevel,
              }"
              @click="blur"
            >
              {{ level.name }}
            </router-link>
            <AddLevelModal>
              <template #anchor="{ onClick }">
                <a class="navbar-item" @click="onClick">
                  <span>
                    <b>+</b>
                    add level
                  </span>
                </a>
              </template>
            </AddLevelModal>
          </div>
        </div>

        <div
          class="navbar-item has-dropdown"
          :class="{ 'is-active': isLogOpen }"
          @click="$store.dispatch('serverLog/toggle')"
        >
          <button class="button is-ghost has-no-shadow">
            <Icon
              class="pt-1"
              :class="[isLogOpen && !isLive ? 'has-text-is-live' : 'has-text-dark']"
              :icon="'terminal'"
            />
          </button>
          <div class="navbar-dropdown is-right">
            <!-- we need to stop propagation to avoid Bulma dropdown close -->
            <ServerLog @click.stop />
          </div>
        </div>
        <div v-if="game" class="navbar-item is-interactive" @click="$store.dispatch('live/toggle')">
          <Icon :class="[isLive ? 'has-text-black' : 'has-text-is-live']" :icon="'play-circle'" />
        </div>
      </div>
    </div>
  </nav>
</template>
